#include <iostream>
#include <sstream>
#include <vector>

using namespace std;

// Alias nv ltrehozsa a vector<vector<int> > tpusra.
typedef vector<vector<int> > matrix;

// Logikai fggvnyek readInt() fggvnyhez.
bool All(int value) { return true; }
bool Positive(int value) { return value > 0; }

// Beolvas egy egsz szmot hibakezelssel. A cond paramterrel tovbbi megszorts adhat meg.
int readInt(const string &msg, const string &err, bool cond(int) = All);

// Az algoritmus "kls" ttele: maximum keress mtrixon.
int maxSearch(const matrix &data);
// Az algoritmus "bels" ttele: sszegzs a mtrix egy oszlopn, azaz egy vektoron.
int sum(const vector<int> &column, int ind);

// Fprogram
int main()
{
    // A mtrix mretnek beolvassa s a mtrix ltrehozsa ennyi oszloppal.
    int n = readInt("Adja meg a matrix meretet: ", "Pozitiv egesz szamot adjon meg!", Positive);
    matrix data(n);

    // A mtrix feltltse.
    for(int i = 0; i < n; ++i)
    {
        // A mtrix i. oszlopt tmretezzk n elemesre a feltltse eltt.
        data[i].resize(n);
        for(int j = 0; j < n; ++j)
        {
            /* Az (i, j). elem beolvassa.
             * A C++ stringstream tpusnak segtsgvel knnyedn sszellthatunk vltoz adatokbl egy stringet.
             * Az ss objektum str() metdusa stringknt visszaadja az objektumban eltrolt szveget.
             */
            stringstream ss;
            ss << "Adja meg a " << (i + 1) << ". oszlop " << (j + 1) << ". soranak erteket: ";
            data[i][j] = readInt(ss.str(), "Egesz szamot adjon meg!");
        }
    }

    // Az algoritmus "kls" ttelnek meghvsa. A visszatrsi rtket egybl ki is iratjuk a konzolra.
    cout << "A(z) " << (maxSearch(data) + 1) << ". oszlopban a legnagyobb a foatlobeli es feletti elemek osszege." << endl;

    return 0;
}

// Az algoritmus "kls" ttele: maximum keress mtrixon.
int maxSearch(const matrix &data)
{
    int ind = 0;
    int max = sum(data[0], 0);
    for(int i = 1; i < data.size(); ++i)
    {
        int sumValue = sum(data[i], i);
        if(sumValue > max)
        {
            ind = i;
            max = sumValue;
        }
    }

    return ind;
}

/* Az algoritmus "bels" ttele: sszegzs a mtrix egy oszlopn, azaz egy vektoron.
 * Fontos, hogy csak a ftlbeli s feletti elemeket kell sszegezni, ehhez szksges tudnunk az oszlop sorszmt is.
 */
int sum(const vector<int> &column, int ind)
{
    int sum = 0;
    for(int i = 0; i <= ind; ++i)
        sum += column[i];

    return sum;
}

// Beolvas egy egsz szmot hibakezelssel. A cond paramterrel tovbbi megszorts adhat meg.
int readInt(const string &msg, const string &errMsg, bool cond(int))
{
    int value;
    bool fail;
    do
    {
        cout << msg;
        cin >> value;
        if(fail = cin.fail() || !cond(value))
        {
            cout << errMsg << endl;
            cin.clear();
            string tmp; getline(cin, tmp);
        }
    }
    while(fail);

    return value;
}
